unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    Xor1: TMenuItem;
    Verschieben1: TMenuItem;
    Beides1: TMenuItem;
    verschlsseln1: TMenuItem;
    Verschlsseln2: TMenuItem;
    Verschlsseln3: TMenuItem;
    Entschlsseln2: TMenuItem;
    Entschlsseln3: TMenuItem;
    Schlieen1: TMenuItem;
    Tausch1: TMenuItem;
    Vreschlsseln1: TMenuItem;
    Entschlsseln1: TMenuItem;
    TauschundVerschieben1: TMenuItem;
    Verschlsseln4: TMenuItem;
    Entschlsseln4: TMenuItem;
    procedure verschlsseln1Click(Sender: TObject);
    procedure Verschlsseln2Click(Sender: TObject);
    procedure Entschlsseln2Click(Sender: TObject);
    procedure Schlieen1Click(Sender: TObject);
    procedure Verschlsseln3Click(Sender: TObject);
    procedure Entschlsseln3Click(Sender: TObject);
    procedure Vreschlsseln1Click(Sender: TObject);
    procedure Entschlsseln1Click(Sender: TObject);
    procedure Verschlsseln4Click(Sender: TObject);
    procedure Entschlsseln4Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const B{Basis = Zahl der Buchstaben ohne Steuerzeichen} = 256 -32;

var
  Form1: TForm1;
implementation

{$R *.DFM}

function XORverschl(const s, passwort: String):String;
  //Damit ein Textfile wieder ein Textfile wird, werden
  //Steuerzeichen wie #1310 nicht verschlsselt, sondern bleiben erhalten.
  var i,q,nr :integer;
begin
  result := s;
  q:=1;
  for i:=1 to Length(result) do  Begin
    if result[i] >= ' ' then BEgin
      nr := Ord(result[i]) XOR Ord(Passwort[q]);
      if nr >= 32 then result[i]:=Chr(nr);
    ENd;
    inc(q);
   if q>length(Passwort) then q:=1;
  end;
end;

function VerschiebeVerschlpos(const s, passwort: String):String;
  //Damit ein Textfile wieder ein Textfile wird, werden
  //Steuerzeichen wie #1310 nicht verschlsselt, sondern bleiben erhalten.
  var i,q,nr :integer;
begin
  result := s;
  q:=1;
  for i:=1 to Length(result) do  Begin
    if result[i] >= ' ' then BEgin
      nr := (Ord(result[i]) - 32) + (Ord(Passwort[q]) - 32);
      if nr > B then nr := nr - B;
      result[i]:=Chr(nr+32);
    ENd;
    inc(q);
   if q>length(Passwort) then q:=1;
  end;
end;

function VerschiebeVerschlneg(const s, passwort: String):String;
  //Damit ein Textfile wieder ein Textfile wird, werden
  //Steuerzeichen wie #1310 nicht verschlsselt, sondern bleiben erhalten.
  var i,q,nr :integer;
begin
  result := s;
  q:=1;
  for i:=1 to Length(result) do  Begin
    if result[i] >= ' ' then BEgin
      nr := (Ord(result[i]) - 32) - (Ord(Passwort[q]) - 32);
      if nr < 0 then nr := nr + B;
      result[i]:=Chr(nr+32);
    ENd;
    inc(q);
   if q>length(Passwort) then q:=1;
  end;
end;

procedure tauscheBuchstaben(const L:integer; var s: string; const j: integer; k:integer);
var c: char;
begin
  while k > L do dec(k,L);
  if (s[j] < #32) or (s[k] < #32) then exit; //keine Steuerzeichen
  c := s[j];
  s[j] := s[k];
  s[k] := c;
end;

procedure vertauschen(const passwort: string; var s: string; vor:boolean);
    var k, L, block, n, m: integer;
  procedure Fallunterscheidung;
       var j, h, u: integer;
    begin
      for j := 1 to n do Begin
        h := 2*j*n;
        for u := 0 to j - 1 do
        if (k mod h) = (j + u*n) then tauscheBuchstaben(L,s,k,block + k + j*n);
      End;
    end;
begin
  L := length(s);
  for m := 1 to length(passwort) do Begin
    if vor then n := ord(passwort[m]) - 31 else
      n:=ord(passwort[length(passwort) - m + 1]) -31;
    if n < 2 then inc(n,31);
    block := L div n;
    form1.memo1.text := inttostr(n);
    application.ProcessMessages; //Damit man wartet
    if vor then for k := 1 to L do Fallunterscheidung
      else for k := L downto 1 do Fallunterscheidung
 End;
end;

function VerschldurchTausch(const s, passwort: String; vor:boolean):String;
begin
  result := s;
  vertauschen(passwort,result,vor);
end;


function liesPasswortUndLoescheErsteZeile: string;
begin
  with form1.Memo1 do Begin
    if lines.count > 0 then BEgin
      result := lines[0];
      lines.delete(0)
    ENd;
  End;
end;

procedure InsertPasswort(const passwort:string);
begin
  form1.Memo1.Lines.Insert(0,passwort);
end;


procedure TForm1.verschlsseln1Click(Sender: TObject);
  var passwort:string;
begin
  passwort := liesPasswortUndLoescheErsteZeile;
  memo1.Text := xorVerschl(memo1.text, passwort);
  InsertPasswort(passwort);
end;

procedure TForm1.Verschlsseln2Click(Sender: TObject);
  var passwort:string;
begin
  passwort := liesPasswortUndLoescheErsteZeile;
  memo1.Text := VerschiebeVerschlpos(memo1.text, passwort);
 InsertPasswort(passwort);
end;

procedure TForm1.Entschlsseln2Click(Sender: TObject);
  var passwort:string;
begin
 passwort := liesPasswortUndLoescheErsteZeile;
 memo1.Text := VerschiebeVerschlneg(memo1.text, passwort);
 InsertPasswort(passwort);
end;

procedure TForm1.Verschlsseln3Click(Sender: TObject);
  var passwort:string;
begin
 passwort := liesPasswortUndLoescheErsteZeile;
 memo1.Text := XorVerschl(VerschiebeVerschlpos(memo1.text,passwort), passwort);
 InsertPasswort(passwort);
end;

procedure TForm1.Entschlsseln3Click(Sender: TObject);
  var passwort:string;
begin
 passwort := liesPasswortUndLoescheErsteZeile;
 memo1.Text := VerschiebeVerschlneg(xorVerschl(memo1.text, passwort), passwort);
 InsertPasswort(passwort);
end;

procedure TForm1.Vreschlsseln1Click(Sender: TObject);
  var passwort:string;
begin
  passwort := liesPasswortUndLoescheErsteZeile;
  memo1.Text := VerschldurchTausch(memo1.text,passwort,true);
 InsertPasswort(passwort);
end;

procedure TForm1.Schlieen1Click(Sender: TObject);
begin
  close
end;


procedure TForm1.Entschlsseln1Click(Sender: TObject);
  var passwort:string;
begin
  passwort := liesPasswortUndLoescheErsteZeile;
  memo1.Text := VerschldurchTausch(memo1.text,passwort,false);
  InsertPasswort(passwort);
end;

procedure TForm1.Verschlsseln4Click(Sender: TObject);
  var passwort:string;
begin
  passwort := liesPasswortUndLoescheErsteZeile;
  memo1.Text := VerschldurchTausch(VerschiebeVerschlpos(memo1.text, passwort),passwort,true);
 InsertPasswort(passwort);
end;

procedure TForm1.Entschlsseln4Click(Sender: TObject);
  var passwort:string;
begin
  passwort := liesPasswortUndLoescheErsteZeile;
  memo1.Text := VerschiebeVerschlneg(VerschldurchTausch(memo1.text,passwort,false), passwort);
  InsertPasswort(passwort);
end;

end.
